# comp_stat_miss_3d

## Authors

Pascal Terray (LOCEAN/IPSL)

## Latest revision

29/04/2026

## Purpose

Compute univariate statistics from a tridimensional variable with missing values extracted from a NetCDF dataset and, optionally, the associated mesh-mask and scale factors of the 2-D grid-mesh associated with the input NetCDF variable.

It is assumed that the input NetCDF variable has a scalar missing_value or _FillValue attribute, which allows a proper identification of the missing values in the dataset, otherwise the procedure will exit with an error message.

Mean, variance, standard-deviation, skewness, kurtosis, minimum and maximum are computed for each point in the multi-channel time series of the 2-D grid-mesh associated with the input NetCDF variable. These statistics are computed by using all available observations for each point time series. Since missing values are present, the number of observations used to compute the statistics may vary from one point to another in the 2-D grid-mesh associated with the NetCDF variable.

These univariate statistics may be computed by taking into account the periodicity of the data. These statistics are stored in an output NetCDF dataset.

Refer to comp_stat_3d, for a precise definition of the statistics and how these univariate statistics are calculated in comp_stat_miss_3d.

This procedure is parallelized if OpenMP is used and the NCSTAT software has been built with the _PARALLEL_READ CPP macro (however, in this version of comp_stat_miss_3d, parellelism is on the number of periods as determined by the -p=periodicity argument. This means that the number of processors or threads must not be greater than the periodicity parameter).

Moreover, this procedure computes all the univariate statistics with only one pass through the data and an out-of-core strategy which is highly efficient on huge datasets.

Optionally, a mesh-mask NetCDF dataset may also be created. This dataset will contain a presence-absence 2-D mask and scale factor variables which may be used to compute the surface of each cell in the 2-D grid-mesh associated with the input NetCDF variable. This mesh-mask NetCDF dataset will be used by other NCSTAT procedures such as comp_serie_miss_3d, comp_eof_miss_3d, etc. When computing the scale factors, it is assumed that the 2-D grid-mesh associated with the input NetCDF variable is regular or that this grid is a regular gaussian grid (the grid of the input NetCDF variable is assumed to be gaussian if this NetCDF variable has a grid_type character attribute with the string “gaussian” as a value).

If your data does not contain missing values, use comp_stat_3d instead of comp_stat_miss_3d to estimate univariate statistics from your dataset.

## Further Details

### Usage

    $ comp_stat_miss_3d \
      -f=input_netcdf_file \
      -v=netcdf_variable \
      -p=periodicity                    (optional) \
      -x=lon1,lon2                      (optional) \
      -y=lat1,lat2                      (optional) \
      -t=time1,time2                    (optional) \
      -o=output_statistics_netcdf_file  (optional) \
      -m=output_mesh_mask_netcdf_file   (optional) \
      -np=nobs_limit_by_period          (optional) \
      -yl=latl1,latl2                   (optional) \
      -mi=missing_value                 (optional) \
      -nobias                           (optional) \
      -stderror                         (optional) \
      -prob                             (optional) \
      -double                           (optional) \
      -bigfile                          (optional) \
      -hdf5                             (optional) \
      -cdf5                             (optional) \
      -tlimited                         (optional)

### By default

> -p=
>   by default, the periodicity is equal to `1`
> -x=
>   the whole longitude domain associated with the netcdf_variable
> -y=
>   the whole latitude domain associated with the netcdf_variable
> -t=
>   the whole time period associated with the netcdf_variable
> -o=
>   the output_statistics_netcdf_file is named `stat_`netcdf_variable`.nc`
> -m=
>   the output_mesh_mask_netcdf_file is not created
> -np=
>   this argument is equal to `0`
> -yl=
>   it is assumed that the grid is gaussian and the domain is the whole globe or that the grid is regular when computing the scale factors
> -mi=
>   by default, the missing_value for the statistic variables is equal to `1.e+20`
> -mi=
>   the missing_value for the statistics variables in the output NetCDF file is set to `1.e+20`
> -nobias
>   biased estimates of kurtosis and skewness coefficients are computed. However, if -nobias is activated, unbiased estimates of kurtosis and skewness are computed
> -stderror
>   the standard errors of the kurtosis and skewness coefficients are not computed. However, if -stderror is activated, these standard errors are computed
> -prob
>   the significance levels of the kurtosis and skewness coefficients are not computed. However, if -prob is activated, these significance levels are computed
> -double
>   the statistic variables are stored as single-precision floating point numbers in the output NetCDF file. If -double is activated, the statistic variables are stored as double-precision floating point numbers
> -bigfile
>   a NetCDF classical format file is created. If -bigfile is activated, the output NetCDF file is a 64-bit offset format file
> -hdf5
>   a NetCDF classical format file is created. If -hdf5 is activated, the output NetCDF file is a NetCDF-4/HDF5 format file
> -cdf5
>   a NetCDF classical format file is created. If -cdf5 is activated, the output NetCDF file is a CDF5 format file
> -tlimited
>   the time dimension is defined as unlimited in the output NetCDF file. However, if -tlimited is activated, the time dimension is defined as limited in the output NetCDF file

### Remarks

> 1. The -v=netcdf_variable argument specifies the NetCDF variable for which statistics must be computed and the -f=input_netcdf_file argument specifies that this NetCDF variable must be extracted from the NetCDF file, input_netcdf_file.

> 2. The -p=periodicity argument gives the periodicity of the input data. For example, with monthly data -p=`12` should be specified, with yearly data -p=`1` may be used, etc. By default, the periodicity is set to `1`. Note that the output NetCDF file will have periodicity time observations.

> 3. If the -x=lon1,lon2 and -y=lat1,lat2 arguments are missing, statistics are computed for all the points of the 2-D grid-mesh associated with the netcdf_variable.

>    The longitude or latitude range must be a vector of two integers specifying the first and last selected indices along each dimension. The indices are relative to `1`. Negative values for lon1 are not allowed.

>    Refer to comp_mask_3d for transforming geographical coordinates as indices before using comp_stat_miss_3d.

> 4. If the -t=time1,time2 argument is missing, the whole time period associated with the netcdf_variable is used to compute the statistics.

>    The selected time period is a vector of two integers specifying the first and last time observations. The indices are relative to `1`.

> 5. It is assumed that the specified netcdf_variable has a scalar missing_value or _FillValue attribute and that missing values in the data are identified by the value of this missing_value attribute.

> 6. If the -m=output_mesh_mask_netcdf_file argument is present and the -yl= argument is missing, it is assumed when computing the scale factors that the 2-D grid-mesh associated with the input NetCDF variable is gaussian and covers the whole globe or that this 2-D grid-mesh is regular.

>    If the grid is a regular gaussian grid, but the domain does not cover the whole globe, the -yl= argument must be used to specify the latitude boundaries of the domain, otherwise the first and last columns (elements) of the first two scale factors are wrong.

>    The -yl= argument specifies the latitude limits of the domain in degrees (latl1 and latl2 must be real numbers) and the ordering of these two values must be coherent with the ordering of the latitudinal coordinate variable in the input_netcdf_file file.

> 7. If the -np=nobs_limit_by_period and -m=output_mesh_mask_netcdf_file arguments are present, the mask in the output_mesh_mask_netcdf_file is constructed as follow:

>    - If the number of observations by period (as determined by the -p= argument) is less than nobs_limit_by_period, the corresponding mask value is set to `0` (e.g., missing), otherwise the mask value is set to `1`.

>    If the -np=nobs_limit_by_period argument is not specified and the -m=output_mesh_mask_netcdf_file argument is present, the mask is constructed as follow:

>    - If the total number of non-missing observations is `0`, the corresponding mask value is set to `0` (e.g., missing), otherwise the mask value is set to `1`.

> 8. If the -m=output_mesh_mask_netcdf_file argument is present and if some scale factors can not be computed, these scale factors are set to `1`.

> 9. The -mi=missing_value argument specifies the missing value indicator for the variance (VAR), standard-deviation (STD), skewness (SKEW) and kurtosis (KURT) variables in the output_statistics_netcdf_file.

>    If the -mi= argument is not specified, the missing_value and _FillValue attributes are set to `1.e+20`.

> 10. If -nobias is specified, unbiased estimates of skewness and kurtosis are computed.

>     If the -nobias argument is absent, the biased standard estimates are computed.

> 11. If -stderror is specified, the standard errors of skewness and kurtosis are computed.

>     If the -stderror argument is absent, the standard errors are not computed.

> 12. If -prob is specified, the significance levels of skewness and kurtosis are computed. Moreover, the -prob argument implies also the -stderror argument, even if this argument is not activated.

>     If the -prob argument is absent, the significance levels are not computed.

> 13. The -double argument specifies that the VAR, STD, SKEW and KURT variables must be stored as double-precision floating point numbers instead of single-precision floating point numbers in the output_statistics_netcdf_file.

> 14. The -bigfile argument is allowed only if the NCSTAT software has been compiled with the _USE_NETCDF36, _USE_NETCDF4 or _USE_NETCDF44 CPP macros (e.g., `-D_USE_NETCDF36` or `-D_USE_NETCDF4` or `-D_USE_NETCDF44`) and linked to the NetCDF 3.6 library or higher.

>     If this argument is specified, the output_netcdf_file will be a 64-bit offset format file instead of a NetCDF classic format file. However, this argument is recognized in the procedure only if the NCSTAT software has been built with the _USE_NETCDF36, _USE_NETCDF4 or _USE_NETCDF44 CPP macros.

> 15. The -hdf5 argument is allowed only if the NCSTAT software has been compiled with the _USE_NETCDF4 or _USE_NETCDF44 CPP macros (e.g., `-D_USE_NETCDF4` or `-D_USE_NETCDF44`) and linked to the NetCDF 4 library or higher.

>     If this argument is specified, the output_netcdf_file will be a NetCDF-4/HDF5 format file instead of a NetCDF classic format file. However, this argument is recognized in the procedure only if the NCSTAT software has been built with the _USE_NETCDF4 or _USE_NETCDF44 CPP macros.

> 16. The -cdf5 argument is allowed only if the NCSTAT software has been compiled with the _USE_NETCDF44 CPP macro (e.g., `-D_USE_NETCDF44`) and linked to the NetCDF 4.4 library or higher.

>     If this argument is specified, the output_netcdf_file will be a CDF5 format file instead of a NetCDF classic format file. However, this argument is recognized in the procedure only if the NCSTAT software has been built with the _USE_NETCDF44 CPP macro.

> 17. At least 4 observations by period, as determined from the -p=periodicity argument, are required, otherwise the program will stop.

> 18. Duplicate parameters are allowed, but this is always the last occurrence of a parameter which will be used for the computations. Moreover, the number of specified parameters must not be greater than the total number of allowed parameters.

> 19. For more details on the use of skewness and kurtosis coefficients in the climate literature see

>     - “Skewness, Kurtosis and Extreme Values of Northern Hemisphere Geopotential Heights”, by White, G., Monthly Weather Review, Vol. 108, 1446-1455, 1980. doi: 10.1175/1520-0493(1980)108<1446:SKAEVO>2.0.CO;2
>     - “The Normality of El Nino”, by Burgers, G., and Stephenson, D.B , Geophysical Research Letters, 26, 1027-1030, 1999. doi: 10.1029/1999GL900161
>     - “Impact of intra-daily SST variability on ENSO characteristics in a coupled model” by Masson, S., et al., Climate Dynamics, Vol. 39, 681-707, 2012. doi: 10.1007/s00382-011-1247-2
>     - “Statistical Analysis in Climate Research”, by von Storch, H., and Zwiers, F.W., Cambridge University press, Cambridge, UK, Chapter 2, 484 pp., 2002. ISBN: 9780521012300

### Outputs

> comp_stat_miss_3d creates an output NetCDF file that contains the univariate statistics and number of observations for the input NetCDF variable, taking into account eventually the periodicity of the data as determined by the -p=periodicity argument. The output NetCDF dataset contains the following NetCDF variables (in the description below, nlat and nlon are the lengths of the spatial dimensions of the input NetCDF variable) :

> 1. netcdf_variable_mean`(periodicity,nlat,nlon)` : the means for each point in the time series of the 2-D grid-mesh associated with the input NetCDF variable.

> 2. netcdf_variable_var`(periodicity,nlat,nlon)` : the variances for each point in the time series of the 2-D grid-mesh associated with the input NetCDF variable.

> 3. netcdf_variable_std`(periodicity,nlat,nlon)` : the standard-deviations for each point in the time series of the 2-D grid-mesh associated with the input NetCDF variable.

> 4. netcdf_variable_skew`(periodicity,nlat,nlon)` : the skewness for each point in the time series of the 2-D grid-mesh associated with the input NetCDF variable.

> 5. netcdf_variable_kurt`(periodicity,nlat,nlon)` : the kurtosis for each point in the time series of the 2-D grid-mesh associated with the input NetCDF variable.

> 6. netcdf_variable_min`(periodicity,nlat,nlon)` : the minima for each point in the time series of the 2-D grid-mesh associated with the input NetCDF variable.

> 7. netcdf_variable_max`(periodicity,nlat,nlon)` : the maxima for each point in the time series of the 2-D grid-mesh associated with the input NetCDF variable.

> 8. netcdf_variable_nobs`(periodicity,nlat,nlon)` : the number of observations used to compute the statistics for each point in the time series of the 2-D grid-mesh associated with the input NetCDF variable.

> 9. netcdf_variable_skew_se`(periodicity,nlat,nlon)` : the standard-errors of the skewness coefficients for each point in the time series of the 2-D grid-mesh associated with the input NetCDF variable.

>    This variable is stored only if the -stderror or -prob arguments have been specified when calling comp_stat_miss_3d.

> 10. netcdf_variable_kurt_se`(periodicity,nlat,nlon)` : the standard-errors of the kurtosis coefficients for each point in the time series of the 2-D grid-mesh associated with the input NetCDF variable.

>     This variable is stored only if the -stderror or -prob arguments have been specified when calling comp_stat_miss_3d.

> 11. netcdf_variable_skew_prob`(periodicity,nlat,nlon)` : the significance levels of the skewness coefficients for each point in the time series of the 2-D grid-mesh associated with the input NetCDF variable.

>     This variable is stored only if the -prob argument has been specified when calling comp_stat_miss_3d.

> 12. netcdf_variable_kurt_prob`(periodicity,nlat,nlon)` : the significance levels of the kurtosis coefficients for each point in the time series of the 2-D grid-mesh associated with the input NetCDF variable.

>     This variable is stored only if the -prob argument has been specified when calling comp_stat_miss_3d.

> All the statistics and associated probabilities, excepted the number of observations and the standard-errors of the skewness and kurtosis coefficients are packed in tridimensional variables whose first and second dimensions are exactly the same as those associated with the input NetCDF variable netcdf_variable even if you restrict the geographical domain with the -x= and -y= arguments. However, outside the selected domain, these output NetCDF variables are filled with missing values.

> Optionally, comp_stat_miss_3d can also create an output mesh-mask NetCDF file that contains the following NetCDF variables, in addition of coordinate variables if they are present in the input NetCDF file :

> 1. netcdf_variable_nmask`(nlat,nlon)` : a presence-absence or land-sea 2-D mask associated with the input NetCDF variable.
> 2. netcdf_variable_e1n`(nlat,nlon)` : the first scale factor associated with the 2-D grid-mesh of the input NetCDF variable.
> 3. netcdf_variable_e2n`(nlat,nlon)` : the second scale factor associated with the 2-D grid-mesh of the input NetCDF variable.

> Multiplying the two scale factors together gives the surface of each cell in the 2-D grid-mesh associated with the input NetCDF variable.

### Examples

> 1. For computing monthly univariate statistics from the NetCDF file `precip.mon.mean.nc`, which includes a NetCDF variable `precip` with missing values, and store the results in a NetCDF file named `stat_cmap_1m_precip.nc`, use the following command :

>        $ comp_stat_miss_3d \
>          -f=precip.mon.mean.nc \
>          -v=precip \
>          -p=12 \
>          -o=stat_cmap_1m_precip.nc

> 2. For computing monthly unbiased univariate statistics from the NetCDF file `precip.mon.mean.nc`, which includes a NetCDF variable `precip` with missing values, and store the results in a NetCDF file named `stat_cmap_1m_precip.nc` and, in addition, generate an associated mesh_mask_netcdf_file named named `mask_cmap_precip.nc`, use the following command :

>        $ comp_stat_miss_3d \
>          -f=precip.mon.mean.nc \
>          -v=precip \
>          -p=12 \
>          -o=stat_cmap_1m_precip.nc \
>          -nobias \
>          -m=mask_cmap_precip.nc